<?php
/*
  Plugin Name: GuruFocus Ticker Links
  Plugin URI: http://www.gurufocus.com/
  Version: 1.0.0
  Author: GuruFocus
  Author URI: http://www.gurufocus.com/
  Description: Plugin links stock tickers such as $AAPL or (GOOG) with the the 10-year financial page at <a href="http://www.gurufocus.com/">GuruFocus.com</a>.
 */

function gurufocus_ticker_links_process_content($content) {
    $user_id = get_option("gurufocus_user_id");

    if ($user_id) {
        $affiliate = "?affid=" . $user_id;
    }

    $content =
            preg_replace(
            '/\$((?:[0-9]+(?=[a-z])|(?![0-9\.\:\_\-]))(?:[a-z0-9]|[\_\.\-\:](?![\.\_\.\-\:]))*[a-z0-9]+)/i', "<a href=\"http://www.gurufocus.com/stock/$1/financials$affiliate\" class=\"ticker\" target=\"_blank\"><span>\$</span>$1</a>", $content
    );

    $content =
            preg_replace(
            '/\(((?:[0-9]+(?=[a-z])|(?![0-9\.\:\_\-]))(?:[a-z0-9]|[\_\.\-\:](?![\.\_\.\-\:]))*[a-z0-9]+)\)/i', "<span>(</span><a href=\"http://www.gurufocus.com/stock/$1/financials$affiliate\" class=\"ticker\" target=\"_blank\">$1</a><span>)</span>", $content
    );

    return $content;
}

add_filter('the_content', 'gurufocus_ticker_links_process_content');
add_filter('the_content_limit', 'gurufocus_ticker_links_process_content');
add_filter('the_excerpt', 'gurufocus_ticker_links_process_content');
add_filter('the_content_rss', 'gurufocus_ticker_links_process_content');
add_filter('the_excerpt_rss', 'gurufocus_ticker_links_process_content');

/** Step 2 (from text above). */
add_action('admin_menu', 'gurufocus_ticker_links_plugin_menu');

/** Step 1. */
function gurufocus_ticker_links_plugin_menu() {
    add_submenu_page('plugins.php', __('GuruFocus Ticker Links Configuration'), __('GuruFocus Ticker Links'), 'manage_options', 'gurufocus_ticker_links', 'gurufocus_ticker_links_conf');
}

/** Step 3. */
function gurufocus_ticker_links_conf() {
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }

    if (isset($_POST['submit'])) {
        $user_id = $_POST['user_id'];
        update_option("gurufocus_user_id", $user_id);
    }

    if (!empty($_POST['submit'])) {
        ?>
        <div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
        <?php
    }

    echo '<div class="wrap">';
    ?>
    <h4><?php _e('GuruFocus Ticker Links:'); ?></h4>
    <h4>Input your Affiliate ID on GuruFocus.com</h4>
    <form action="" method="post" id="gurufocus-ticker-links-conf">
        <h3><label for="user_id">Affiliate ID</label></h3>
        <p><input name="user_id" id="user_id" value="<?php echo get_option("gurufocus_user_id"); ?>" />
            (<a href="https://www.gurufocus.com/user/me?tab=account&subtab=account-aff" target="_blank">Get this?</a>)
        </p>
        <p class="submit"><input type="submit" name="submit" value="<?php _e('Update options &raquo;'); ?>" /></p>
    </form>
    <?php
    echo '</div>';
}
?>
